<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>Vote.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server.quorum</a> &gt; <span class="el_source">Vote.java</span></div><h1>Vote.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server.quorum;

import org.apache.zookeeper.server.quorum.QuorumPeer.ServerState;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;


public class Vote {
<span class="fc" id="L27">    private static final Logger LOG = LoggerFactory.getLogger(Vote.class);</span>
    
    public Vote(long id, 
<span class="fc" id="L30">                    long zxid) {</span>
<span class="fc" id="L31">        this.version = 0x0;</span>
<span class="fc" id="L32">        this.id = id;</span>
<span class="fc" id="L33">        this.zxid = zxid;</span>
<span class="fc" id="L34">        this.electionEpoch = -1;</span>
<span class="fc" id="L35">        this.peerEpoch = -1;</span>
<span class="fc" id="L36">        this.state = ServerState.LOOKING;</span>
<span class="fc" id="L37">    }</span>
    
    public Vote(long id, 
                    long zxid, 
<span class="fc" id="L41">                    long peerEpoch) {</span>
<span class="fc" id="L42">        this.version = 0x0;</span>
<span class="fc" id="L43">        this.id = id;</span>
<span class="fc" id="L44">        this.zxid = zxid;</span>
<span class="fc" id="L45">        this.electionEpoch = -1;</span>
<span class="fc" id="L46">        this.peerEpoch = peerEpoch;</span>
<span class="fc" id="L47">        this.state = ServerState.LOOKING;</span>
<span class="fc" id="L48">    }</span>

    public Vote(long id, 
                    long zxid, 
                    long electionEpoch, 
<span class="fc" id="L53">                    long peerEpoch) {</span>
<span class="fc" id="L54">        this.version = 0x0;</span>
<span class="fc" id="L55">        this.id = id;</span>
<span class="fc" id="L56">        this.zxid = zxid;</span>
<span class="fc" id="L57">        this.electionEpoch = electionEpoch;</span>
<span class="fc" id="L58">        this.peerEpoch = peerEpoch;</span>
<span class="fc" id="L59">        this.state = ServerState.LOOKING;</span>
<span class="fc" id="L60">    }</span>
    
    public Vote(int version,
                    long id, 
                    long zxid, 
                    long electionEpoch, 
                    long peerEpoch, 
<span class="fc" id="L67">                    ServerState state) {</span>
<span class="fc" id="L68">        this.version = version;</span>
<span class="fc" id="L69">        this.id = id;</span>
<span class="fc" id="L70">        this.zxid = zxid;</span>
<span class="fc" id="L71">        this.electionEpoch = electionEpoch;</span>
<span class="fc" id="L72">        this.state = state;</span>
<span class="fc" id="L73">        this.peerEpoch = peerEpoch;</span>
<span class="fc" id="L74">    }</span>
    
    public Vote(long id, 
                    long zxid, 
                    long electionEpoch, 
                    long peerEpoch, 
<span class="fc" id="L80">                    ServerState state) {</span>
<span class="fc" id="L81">        this.id = id;</span>
<span class="fc" id="L82">        this.zxid = zxid;</span>
<span class="fc" id="L83">        this.electionEpoch = electionEpoch;</span>
<span class="fc" id="L84">        this.state = state;</span>
<span class="fc" id="L85">        this.peerEpoch = peerEpoch;</span>
<span class="fc" id="L86">        this.version = 0x0;</span>
<span class="fc" id="L87">    }</span>
    
    final private int version;
    
    final private long id;
    
    final private long zxid;
    
    final private long electionEpoch;
    
    final private long peerEpoch;
    
    public int getVersion() {
<span class="nc" id="L100">        return version;</span>
    }
    
    public long getId() {
<span class="fc" id="L104">        return id;</span>
    }

    public long getZxid() {
<span class="fc" id="L108">        return zxid;</span>
    }

    public long getElectionEpoch() {
<span class="fc" id="L112">        return electionEpoch;</span>
    }

    public long getPeerEpoch() {
<span class="fc" id="L116">        return peerEpoch;</span>
    }

    public ServerState getState() {
<span class="fc" id="L120">        return state;</span>
    }

    final private ServerState state;
    
    @Override
    public boolean equals(Object o) {
<span class="pc bpc" id="L127" title="1 of 2 branches missed.">        if (!(o instanceof Vote)) {</span>
<span class="nc" id="L128">            return false;</span>
        }
<span class="fc" id="L130">        Vote other = (Vote) o;</span>
        
        
        /*
         * There are two things going on in the logic below.
         * First, we compare votes of servers out of election
         * using only id and peer epoch. Second, if one version
         * is 0x0 and the other isn't, then we only use the
         * leader id. This case is here to enable rolling upgrades.
         * 
         * {@see https://issues.apache.org/jira/browse/ZOOKEEPER-1805}
         */
<span class="fc bfc" id="L142" title="All 4 branches covered.">        if ((state == ServerState.LOOKING) ||</span>
                (other.state == ServerState.LOOKING)) {
<span class="fc bfc" id="L144" title="All 8 branches covered.">            return (id == other.id</span>
                    &amp;&amp; zxid == other.zxid
                    &amp;&amp; electionEpoch == other.electionEpoch
                    &amp;&amp; peerEpoch == other.peerEpoch);
        } else {
<span class="fc bfc" id="L149" title="All 6 branches covered.">            if ((version &gt; 0x0) ^ (other.version &gt; 0x0)) {</span>
<span class="pc bpc" id="L150" title="1 of 2 branches missed.">                return id == other.id;</span>
            } else {
<span class="pc bpc" id="L152" title="1 of 4 branches missed.">                return (id == other.id</span>
                        &amp;&amp; peerEpoch == other.peerEpoch);
            }
        } 
    }

    @Override
    public int hashCode() {
<span class="fc" id="L160">        return (int) (id &amp; zxid);</span>
    }

    public String toString() {
<span class="fc" id="L164">        return String.format(&quot;(%d, %s, %s)&quot;,</span>
<span class="fc" id="L165">                                id,</span>
<span class="fc" id="L166">                                Long.toHexString(zxid),</span>
<span class="fc" id="L167">                                Long.toHexString(peerEpoch));</span>
    }
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>